#!/bin/bash

TEMP_OLD1=20
TEMP_OLD2=20
TEMP_OLD3=20
TEMP_OLD4=20
PWM_IST=0
PWM_SOLL=0

while [ true ]; do
  TEMP=`/usr/bin/SMTGetTemp`
  TEMP_WEIGHTED=$((((${TEMP} + ${TEMP_OLD1} + ${TEMP_OLD2} + ${TEMP_OLD3} + ${TEMP_OLD4}) / 5))) 

  if [ ${TEMP_WEIGHTED} -ge 45 ]; then
    PWM_SOLL=175  
  else    
    if [ ${TEMP_WEIGHTED} -ge 42 ]; then
      PWM_SOLL=125  
    else    
      if [ ${TEMP_WEIGHTED} -ge 40 ]; then
        PWM_SOLL=110  
      else    
        if [ ${TEMP_WEIGHTED} -ge 38 ]; then
          PWM_SOLL=95  
        else    
          if [ ${TEMP_WEIGHTED} -ge 35 ]; then
            PWM_SOLL=75  
          else
            if [ ${TEMP_WEIGHTED} -ge 33 ]; then
              PWM_SOLL=55  
            else
              PWM_SOLL=0    
            fi
          fi
        fi
      fi
    fi
  fi

  if [ ${PWM_IST} -lt ${PWM_SOLL} ]; then
    PWM_IST=$((${PWM_IST} + 1))
  fi

  if [ ${PWM_IST} -gt ${PWM_SOLL} ]; then
    PWM_IST=$((${PWM_IST} - 1))
  fi

  if [ ${PWM_IST} -lt 50 ]; then
    PWM_IST_OUT=0
  else
    PWM_IST_OUT=${PWM_IST}
  fi
      
  /usr/bin/SMTSetPWM -s ${PWM_IST_OUT}

#  echo "TEMP:$TEMP, TEMP_WEIGHTED:$TEMP_WEIGHTED, PWM_SOLL:$PWM_SOLL, PWM_IST:$PWM_IST"
  
  TEMP_OLD4=$TEMP_OLD3
  TEMP_OLD3=$TEMP_OLD2
  TEMP_OLD2=$TEMP_OLD1
  TEMP_OLD1=$TEMP
  
  sleep 1
done
